// C Source File
// Created 6/23/2002; 4:25:25 PM

#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

int speed=75;
int highscore=0;

void delay(void) {
	short int loop = speed, randNum;
	
	// generate random numbers to slow down the program...
	while (loop-- > 0) {
		randNum = rand() % loop;
	}
}

// Main Function
void _main(void)
{
	static unsigned char arrowd[]={0xFF,0x99,0xBD,0xBD,0xDB,0x66,0x3C,0x18};
	static unsigned char arrowl[]={0x1F,0x31,0x6D,0xDF,0xDF,0x6D,0x31,0x1F};
	static unsigned char arrowu[]={0x18,0x3C,0x66,0xDB,0xBD,0xBD,0x99,0xFF};
	static unsigned char arrowr[]={0xF8,0x8C,0xB6,0xFB,0xFB,0xB6,0x8C,0xF8};
	static unsigned char man[]={0x3C,0x42,0xA5,0x81,0xA5,0x99,0x42,0x3C};
	static unsigned char bord[]={0xBF,0xA0,0xAE,0xAA,0xAA,0xBA,0x82,0xFE};
	int x,y,key;
	int mcnt;
	int hlim,hcnt;
	int vlim,vcnt;
	int adx,ady;
	int aux,auy;
	int alx,aly;
	int arx,ary;
	int score;
	randomize();
	ClrScr();
	FontSetSys(F_8x10);
	printf_xy(47,10,"Arrows!");
	FontSetSys(F_6x8);
	printf_xy(25,25,"By: Phil Software");
	printf_xy(43,60,"Press Enter");
	FontSetSys(F_4x6);
	printf_xy(0,85,"version 1.1");
	for (x=0;x<=152;x+=8){
		Sprite8(x,0,8,bord,LCD_MEM,SPRT_XOR);
	}
	for (x=0;x<=152;x+=8){
		Sprite8(x,91,8,bord,LCD_MEM,SPRT_XOR);
	}
	ngetchx();
	x=76;y=46;speed=75;mcnt=0;hlim=13;hcnt=0;vlim=16;vcnt=0;score=0;
	adx=-99;ady=-99;aux=-99;auy=-99;alx=-99;aly=-99;arx=-99;ary=-99;
	ClrScr();
	Sprite8(x,y,8,man,LCD_MEM,SPRT_XOR);
	INT_HANDLER interrupt1 = GetIntVec(AUTO_INT_1);
	SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
	while (1==1){
		mcnt++;
		if (mcnt==5){
			mcnt=0;
			key=_rowread(0xFFFE);
			if (key&0x0001&&y>0){//up
				Sprite8(x,y,8,man,LCD_MEM,SPRT_XOR);
				y--;
				Sprite8(x,y,8,man,LCD_MEM,SPRT_XOR);
			}
			if (key&0x0004&&y<91){//down
				Sprite8(x,y,8,man,LCD_MEM,SPRT_XOR);
				y++;
				Sprite8(x,y,8,man,LCD_MEM,SPRT_XOR);
			}
			if (key&0x0002&&x>0){//left
				Sprite8(x,y,8,man,LCD_MEM,SPRT_XOR);
				x--;
				Sprite8(x,y,8,man,LCD_MEM,SPRT_XOR);
			}
			if (key&0x0008&&x<151){//right
				Sprite8(x,y,8,man,LCD_MEM,SPRT_XOR);
				x++;
				Sprite8(x,y,8,man,LCD_MEM,SPRT_XOR);
			}
			if (x+2>=alx&&x<=alx+6&&y+2>=aly&&y<=aly+6){
				break;
			}
			if (x+2>=arx&&x<=arx+6&&y+2>=ary&&y<=ary+6){
				break;
			}
			if (x+2>=aux&&x<=aux+6&&y+2>=auy&&y<=auy+6){
				break;
			}
			if (x+2>=adx&&x<=adx+6&&y+2>=ady&&y<=ady+6){
				break;
			}
			score++;
		}
		hcnt++;
		if (hcnt==hlim){
			hcnt=0;
			if (alx==-99){
				alx=158;
				arx=-7;
				aly=random(90);
				ary=random(90);
				Sprite8(alx,aly,8,arrowl,LCD_MEM,SPRT_XOR);
				Sprite8(arx,ary,8,arrowr,LCD_MEM,SPRT_XOR);
				if (speed-1){speed--;}
				if (hlim>1){hlim--;}
			}
			Sprite8(alx,aly,8,arrowl,LCD_MEM,SPRT_XOR);
			Sprite8(arx,ary,8,arrowr,LCD_MEM,SPRT_XOR);
			alx--;arx++;
			Sprite8(alx,aly,8,arrowl,LCD_MEM,SPRT_XOR);
			Sprite8(arx,ary,8,arrowr,LCD_MEM,SPRT_XOR);
			if (alx==-7){
				Sprite8(alx,aly,8,arrowl,LCD_MEM,SPRT_XOR);
				Sprite8(arx,ary,8,arrowr,LCD_MEM,SPRT_XOR);
				alx=-99;
				arx=-99;
			}
		}
		vcnt++;
		if (vcnt==vlim){
			vcnt=0;
			if (auy==-99){
				auy=98;
				ady=-7;
				aux=random(150);
				adx=random(150);
				Sprite8(aux,auy,8,arrowu,LCD_MEM,SPRT_XOR);
				Sprite8(adx,ady,8,arrowd,LCD_MEM,SPRT_XOR);
				if (vlim>1){vlim--;}
			}
			Sprite8(aux,auy,8,arrowu,LCD_MEM,SPRT_XOR);
			Sprite8(adx,ady,8,arrowd,LCD_MEM,SPRT_XOR);
			auy--;ady++;
			Sprite8(aux,auy,8,arrowu,LCD_MEM,SPRT_XOR);
			Sprite8(adx,ady,8,arrowd,LCD_MEM,SPRT_XOR);
			if (auy==-7){
				Sprite8(aux,auy,8,arrowu,LCD_MEM,SPRT_XOR);
				Sprite8(adx,ady,8,arrowd,LCD_MEM,SPRT_XOR);
				auy=-99;
				ady=-99;
			}
		}
		if (_rowread(~((short)(1<<1))) & (1<<6)){//clear
			break;
		}
		delay();
	}
	SetIntVec(AUTO_INT_1,interrupt1);
	for (x=0;x<=3000;x++){
		rand()%x;
	}
	if (kbhit()){
		ngetchx();
	}
	if (kbhit()){
		ngetchx();
	}
	ngetchx();
	FontSetSys(F_8x10);
	printf_xy(30,30,"Score:  %d",score);
	if (score>highscore){highscore=score;}
	printf_xy(20,42,"HighScore:  %d", highscore);
	ngetchx();
}
